=begin
(c) TIG 2009

    scale2face.rb
    
Usage:
    Select face(s) & group/component-instance(s) located below face(s).
    
Unacceptable selections produce error dialogs.

Pick 'Scale2Face' off the Plugins Menu
or type scale2face in the Ruby Console.

The selected items will be 
scaled upwards [in the Z] until their CLs meet the face or faces.

Any intermediate faces etc are ignored; the scaling passes through them.

It has a one step un-do.

To Do: Alternative orientations to just the UP in Z.
       E.G. down and in XY

Version: 1.0 20090717 First Release.
         1.1 20090721 Tweaked to avoid height glitches.
         1.2 20090811 Multi-face support added.  Error msgs disabled.
         1.3 20090819 Now works within groups/component edits.
=end
def scale2face()
  model=Sketchup.active_model
  ###
  model.start_operation("拉伸到面")
  ###
  ss=model.selection
  faces=[];ss.each{|e|faces<<e if e.kind_of?(Sketchup::Face)}
  if not faces[0]
    UI.messagebox("当前选择中没有面被选中。\n\n请重新选择后再使用本工具...")
    return nil
  end#if
  #if faces[1]
    #UI.messagebox(">1 Face in Selection.\n\nTry again...")
    #return nil
  #end#if
  #face=faces[0]
  ### error trap for selected face or pick on screen
  items=[];ss.each{|e|items<<e if e.kind_of?(Sketchup::Group) or e.kind_of?(Sketchup::ComponentInstance)}
  if not items[0]
    UI.messagebox("当前选择中没有群组或组件实例被选中。\n\n请重新选择后再使用本工具...")
    return nil
  end#if
 faces.each{|face|###v1.2
  items.each{|e|
    bb=e.bounds
    cZ=bb.max.z - bb.min.z ### Z
    minz=bb.min.z
    maxz=bb.max.z
    centermin=bb.center.clone
    centermin.z=minz
    centermax=bb.center.clone
    centermax.z=maxz
    pt=centermax.clone
    raytest=[pt,nil]
    hitFace=nil
    while pt and not hitFace.to_s == face.to_s
      ray=[pt,Geom::Vector3d.new(0,0,1)]### up
      raytest=model.raytest(ray)
      if raytest
        pt=raytest[0].clone
        hitFace=raytest[1].last ### v1.3 if in 'edit' mode...
      else
        pt=nil
      end#if
    end#while
    if hitFace.to_s == face.to_s
      newZ=centermin.distance(pt)
      scal=newZ/cZ
      tr=Geom::Transformation.scaling(centermin,1,1,scal)
      e.transform!(tr)
    end#if
  }
 }####v1.2
  model.commit_operation
  ###
end#def
scriptname = File.basename(__FILE__)
unless file_loaded?(scriptname )
  menu = UI.menu("Plugins").add_item("拉伸到面"){scale2face}
  file_loaded(scriptname)
end
    # 以下部分是添加图标的代码
    toolbar = UI::Toolbar.new "拉伸到面"
    cmd = UI::Command.new("拉伸到面") {scale2face}
    cmd.tooltip = "拉伸到面"
    cmd.status_bar_text = '同时选中群组/组件以及一个面，然后使用此工具可自动将群组/组件在Z轴方向上拉伸到面的位置。'
    cmd.small_icon = "scale2face/icon.png"
    cmd.large_icon = "scale2face/icon.png"
    toolbar = toolbar.add_item cmd
    toolbar.show
    puts cmd.large_icon
    # 以上部分是添加图标的代码